#include "AtomProperty.h"

using namespace std;
using namespace compound;


AtomProperty::AtomProperty()
{
    this->handNumber = 0;
}


AtomProperty::AtomProperty(int hand)
{
    this->handNumber = hand;
}


int AtomProperty::getHandNumber()
{
    return this->handNumber;
}


AtomProperties::AtomProperties()
{
    initProperties();
}


void AtomProperties::initProperties()
{
    properties["H"]   = AtomProperty(1);
    properties["He"]  = AtomProperty(0);
    properties["Li"]  = AtomProperty(1);
    properties["Be"]  = AtomProperty(2);
    properties["B"]   = AtomProperty(3);
    properties["C"]   = AtomProperty(4);
    properties["N"]   = AtomProperty(3);
    properties["O"]   = AtomProperty(2);
    properties["F"]   = AtomProperty(1);
    properties["Ne"]  = AtomProperty(0);
    properties["Na"]  = AtomProperty(1);
    properties["Mg"]  = AtomProperty(2);
    properties["Al"]  = AtomProperty(3);
    properties["Si"]  = AtomProperty(4);
    properties["P"]   = AtomProperty(3);
    properties["S"]   = AtomProperty(2);
    properties["Cl"]  = AtomProperty(1);
    properties["Ar"]  = AtomProperty(0);
    properties["K"]   = AtomProperty(1);
    properties["Ca"]  = AtomProperty(2);
    properties["Sc"]  = AtomProperty(0);
    properties["Ti"]  = AtomProperty(0);
    properties["V"]   = AtomProperty(0);
    properties["Cr"]  = AtomProperty(0);
    properties["Mn"]  = AtomProperty(0);
    properties["Fe"]  = AtomProperty(0);
    properties["Co"]  = AtomProperty(0);
    properties["Ni"]  = AtomProperty(0);
    properties["Cu"]  = AtomProperty(0);
    properties["Zn"]  = AtomProperty(0);
    properties["Ga"]  = AtomProperty(3);
    properties["Ge"]  = AtomProperty(0);
    properties["As"]  = AtomProperty(0);
    properties["Se"]  = AtomProperty(0);
    properties["Br"]  = AtomProperty(0);  // --
    properties["Kr"]  = AtomProperty(0);
    properties["Rb"]  = AtomProperty(1);
    properties["Sr"]  = AtomProperty(2);
    properties["Y"]   = AtomProperty(0);
    properties["Zr"]  = AtomProperty(0);
    properties["Nb"]  = AtomProperty(0);
    properties["Mo"]  = AtomProperty(0);
    properties["Tc"]  = AtomProperty(0);
    properties["Ru"]  = AtomProperty(0);
    properties["Rh"]  = AtomProperty(0);
    properties["Pd"]  = AtomProperty(0);
    properties["Ag"]  = AtomProperty(0);
    properties["Cd"]  = AtomProperty(0);
    properties["In"]  = AtomProperty(3);
    properties["Sn"]  = AtomProperty(0);
    properties["Sb"]  = AtomProperty(0);
    properties["Te"]  = AtomProperty(0);
    properties["I"]   = AtomProperty(0);
    properties["Xe"]  = AtomProperty(0);
    properties["Cs"]  = AtomProperty(1);
    properties["Ba"]  = AtomProperty(2);
    properties["La"]  = AtomProperty(0);
    properties["Ce"]  = AtomProperty(0);
    properties["Pr"]  = AtomProperty(1);
    properties["Nd"]  = AtomProperty(0);
    properties["Pm"]  = AtomProperty(0);
    properties["Sm"]  = AtomProperty(0);
    properties["Eu"]  = AtomProperty(0);
    properties["Gd"]  = AtomProperty(0);
    properties["Tb"]  = AtomProperty(0);
    properties["Dy"]  = AtomProperty(0);
    properties["Ho"]  = AtomProperty(0);
    properties["Er"]  = AtomProperty(0);
    properties["Tm"]  = AtomProperty(0);
    properties["Yb"]  = AtomProperty(0);
    properties["Lu"]  = AtomProperty(0);
    properties["Hf"]  = AtomProperty(0);
    properties["Ta"]  = AtomProperty(0);
    properties["W"]   = AtomProperty(0);
    properties["Re"]  = AtomProperty(0);
    properties["Os"]  = AtomProperty(0);
    properties["Ir"]  = AtomProperty(0);
    properties["Pt"]  = AtomProperty(0);
    properties["Au"]  = AtomProperty(0);
    properties["Hg"]  = AtomProperty(0);
    properties["Tl"]  = AtomProperty(0);
    properties["Pb"]  = AtomProperty(0);
    properties["Bi"]  = AtomProperty(0);
    properties["Po"]  = AtomProperty(0);
    properties["At"]  = AtomProperty(0);
    properties["Rn"]  = AtomProperty(0);
    properties["Fr"]  = AtomProperty(0);
    properties["Ra"]  = AtomProperty(0);
    properties["Ac"]  = AtomProperty(0);
    properties["Th"]  = AtomProperty(0);
    properties["Pa"]  = AtomProperty(0);
    properties["U"]   = AtomProperty(0);
    properties["Np"]  = AtomProperty(0);
    properties["Pu"]  = AtomProperty(0);
    properties["Am"]  = AtomProperty(0);
    properties["Cm"]  = AtomProperty(0);
    properties["Bk"]  = AtomProperty(0);
    properties["Cf"]  = AtomProperty(0);
    properties["Es"]  = AtomProperty(0);
    properties["Fm"]  = AtomProperty(0);
    properties["Md"]  = AtomProperty(0);
    properties["No"]  = AtomProperty(0);
    properties["Lr"]  = AtomProperty(0);
    properties["Rf"]  = AtomProperty(0);
    properties["Db"]  = AtomProperty(0);
    properties["Sg"]  = AtomProperty(0);
    properties["Bh"]  = AtomProperty(0);
    properties["Hs"]  = AtomProperty(0);
    properties["Mt"]  = AtomProperty(0);
}


AtomProperty AtomProperties::getProperty(string symbol)
{
    AtomProperty ret;

    if(properties.count(symbol) > 0)
    {
        ret = properties[symbol];
    }

    return ret;
}
