#include "Bracket.h"

using namespace std;
using namespace compound;
using namespace utils;


Border::Border()
{
}


Border::Border(PointDbl first, PointDbl second)
{
    setFirstPoint(first);
    setSecondPoint(second);
}


void Border::setFirstPoint(PointDbl point)
{
    this->firstPoint = point;
}


PointDbl Border::getFirstPoint()
{
    return firstPoint;
}


void Border::setSecondPoint(PointDbl point)
{
    this->secondPoint = point;
}


PointDbl Border::getSecondPoint()
{
    return secondPoint;
}


void Border::move(double x, double y)
{
    firstPoint.setX(firstPoint.getX() + x);
    firstPoint.setY(firstPoint.getY() + y);

    secondPoint.setX(secondPoint.getX() + x);
    secondPoint.setY(secondPoint.getY() + y);
}


void Border::scale(double xTimes, double yTimes)
{
    firstPoint.setX(firstPoint.getX() * xTimes);
    firstPoint.setY(firstPoint.getY() * yTimes);

    secondPoint.setX(secondPoint.getX() * xTimes);
    secondPoint.setY(secondPoint.getY() * yTimes);
}


Bracket::Bracket()
{
    firstBorder = new Border();
    secondBorder = new Border();
}


Bracket::~Bracket()
{
    delete firstBorder;
    delete secondBorder;
}


Border *Bracket::getFirstBorder() const
{
    return firstBorder;
}


Border *Bracket::getSecondBorder() const
{
    return secondBorder;
}


void Bracket::setSubscript(string subscript)
{
    this->subscript = subscript;
}


string Bracket::getSubscript() const
{
    return subscript;
}


void Bracket::move(double x, double y)
{
    getFirstBorder()->move(x, y);
    getSecondBorder()->move(x, y);
}

void Bracket::scale(double times)
{
    scale(times, times);
}


void Bracket::scale(double xTimes, double yTimes)
{
    getFirstBorder()->scale(xTimes, yTimes);
    getSecondBorder()->scale(xTimes, yTimes);
}


double compound::getBracketMinX(Bracket *bracket)
{
    double ret = DBL_MAX;

    Border *border1 = bracket->getFirstBorder();
    Border *border2 = bracket->getSecondBorder();

    if(border1->getFirstPoint().getX() < ret)
        ret = border1->getFirstPoint().getX();

    if(border1->getSecondPoint().getX() < ret)
        ret = border1->getSecondPoint().getX();

    if(border2->getFirstPoint().getX() < ret)
        ret = border2->getFirstPoint().getX();

    if(border2->getSecondPoint().getX() < ret)
        ret = border2->getSecondPoint().getX();

    return ret;
}


double compound::getBracketMaxX(Bracket *bracket)
{
    double ret = -DBL_MAX;

    Border *border1 = bracket->getFirstBorder();
    Border *border2 = bracket->getSecondBorder();

    if(border1->getFirstPoint().getX() > ret)
        ret = border1->getFirstPoint().getX();

    if(border1->getSecondPoint().getX() > ret)
        ret = border1->getSecondPoint().getX();

    if(border2->getFirstPoint().getX() > ret)
        ret = border2->getFirstPoint().getX();

    if(border2->getSecondPoint().getX() > ret)
        ret = border2->getSecondPoint().getX();

    return ret;
}


double compound::getBracketMinY(Bracket *bracket)
{
    double ret = DBL_MAX;

    Border *border1 = bracket->getFirstBorder();
    Border *border2 = bracket->getSecondBorder();

    if(border1->getFirstPoint().getY() < ret)
        ret = border1->getFirstPoint().getY();

    if(border1->getSecondPoint().getY() < ret)
        ret = border1->getSecondPoint().getY();

    if(border2->getFirstPoint().getY() < ret)
        ret = border2->getFirstPoint().getY();

    if(border2->getSecondPoint().getY() < ret)
        ret = border2->getSecondPoint().getY();

    return ret;
}


double compound::getBracketMaxY(Bracket *bracket)
{
    double ret = -DBL_MAX;

    Border *border1 = bracket->getFirstBorder();
    Border *border2 = bracket->getSecondBorder();

    if(border1->getFirstPoint().getY() > ret)
        ret = border1->getFirstPoint().getY();

    if(border1->getSecondPoint().getY() > ret)
        ret = border1->getSecondPoint().getY();

    if(border2->getFirstPoint().getY() > ret)
        ret = border2->getFirstPoint().getY();

    if(border2->getSecondPoint().getY() > ret)
        ret = border2->getSecondPoint().getY();

    return ret;
}
