#ifndef __COMPOUND_BRACKET__
#define __COMPOUND_BRACKET__

#include <float.h>
#include <string>
#include "../utils/Rectangle.h"

namespace compound
{
    class Border
    {
        private:
            Border(const Border &other);
            Border &operator=(const Border &oher);

            utils::PointDbl firstPoint, secondPoint;

        public:
            Border();
            Border(utils::PointDbl first, utils::PointDbl second);

            void setFirstPoint(utils::PointDbl);
            utils::PointDbl getFirstPoint();

            void setSecondPoint(utils::PointDbl);
            utils::PointDbl getSecondPoint();

            void move(double x, double y);
            void scale(double xTimes, double yTimes);
    };


    class Bracket
    {
        private:
            Bracket(const Bracket &other);
            Bracket &operator=(const Bracket &other);

            Border *firstBorder, *secondBorder;

            std::string subscript;

        public:
            Bracket();
            virtual ~Bracket();

            void setSubscript(std::string subscript);
            std::string getSubscript() const;

            Border *getFirstBorder() const;
            Border *getSecondBorder() const;

            void move(double x, double y);
            void scale(double times);
            void scale(double xTimes, double yTimes);
    };


    double getBracketMinX(Bracket *bracket);
    double getBracketMaxX(Bracket *bracket);
    double getBracketMinY(Bracket *bracket);
    double getBracketMaxY(Bracket *bracket);
}

#endif
