#ifndef __COMPOUND_BRACKET_IMAGE__
#define __COMPOUND_BRACKET_IMAGE__

#include "../image/Image.h"
#include "Bracket.h"
#include "../utils/Utils.h"

namespace compound
{
    class BracketImage
    {
        private:
            static const double BRACKET_LENGTH;
            image::Image *image;

            void drawFirstBorder(Border *border);
            void drawSecondBorder(Border *border);
            void drawBracketSubscript(Bracket *bracket);

        public:
            BracketImage(image::Image *image);

            void drawBracket(Bracket *bracket);

            utils::RectangleDbl getBracketRegion(Bracket *bracket);
    };
}

#endif
