#ifndef __COMPOUND_MOLREAER__
#define __COMPOUND_MOLREAER__

#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <map>
#include <string.h>
#include <stdlib.h>

#include "Molecule.h"

namespace compound
{
    class MolReader
    {
        private:
            std::map<Bracket *, int> bracketDisplayInfo;

            bool read(Molecule *mol, std::istream &in);
            bool readAtoms(Molecule *mol, std::istream &in, int atomNumber);
            bool readBonds(Molecule *mol, std::istream &in, int bondNumber);
            bool readProperties(Molecule *mol, std::istream &in);
            bool readCharge(Molecule *mol, std::string line);
            bool readIsotope(Molecule *mol, std::string line);
            bool readSgroupType(Molecule *mol, std::string line);
            bool readSgroupSubscript(Molecule *mol, std::string line);
            bool readSgroupDisplayInformation(Molecule *mol, std::string line);

        public:
            bool readMol(Molecule *mol, std::string str);
            bool readMolFile(Molecule *mol, std::string file);
    };
}

#endif
