#ifndef __COMPOUND_MOLECULE_KCFREADER__
#define __COMPOUND_MOLECULE_KCFREADER__

#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <string.h>

#include "Molecule.h"

namespace compound
{
    class MoleculeKcfReader
    {
        private:
            bool read(compound::Molecule *mol, std::istream &in);
            bool readAtoms(compound::Molecule *mol, std::istream &in, int atomNumber);
            bool readBonds(compound::Molecule *mol, std::istream &in, int bondNumber);
            bool readBracket(Molecule *mol, std::string block);
            bool readRepeatAtom(Molecule *mol, std::string line);

            std::string getColor(const std::string str);
            int getCharge(const std::string str);

        public:
            bool readKcf(compound::Molecule *mol, std::string str);
            bool readKcfFile(compound::Molecule *mol, std::string file);
    };
}

#endif
