#ifndef __COMPOUND_RING__
#define __COMPOUND_RING__

#include <float.h>
#include <vector>
#include "Bond.h"
#include "../utils/Point.h"

namespace compound
{
    class Ring
    {
        private:
            std::vector<Bond *> bonds;

        public:
            Ring();
            Ring(std::vector<Bond *>);

            void addBond(Bond *bond);
            Bond *getBond(size_t index) const;
            size_t getBondNumber() const;

            bool isMember(Bond *bond) const;
            Bond *getConnectedBond(Bond *bond, Atom *atom) const;

            utils::PointDbl getCenter();

            bool operator==(const Ring &other) const;
    };
}

#endif
