#ifndef __COMPOUND_SIMPLE_RING_CHECKER__
#define __COMPOUND_SIMPLE_RING_CHECKER__

#include <vector>
#include <algorithm>
#include "Ring.h"
#include "Molecule.h"

namespace compound
{
    class Molecule;

    class SimpleRingChecker
    {
        private:
            static const int MAX_DEPTH;

            std::vector<Bond *> bonds;
            std::vector<Bond *> routedBonds;

            bool searchRing(Atom *firstAtom, Atom *currentAtom, Bond *routeBond, int depth);

            bool isRoutedBond(Bond *bond);

        public:
            SimpleRingChecker();

            std::vector<Ring> getRing(Molecule *mol);
    };
}

#endif
