#ifndef __GLYCAN_GLYCAN_IMAGE__
#define __GLYCAN_GLYCAN_IMAGE__

#include <float.h>

#include "../image/Image.h"
#include "../utils/Utils.h"
#include "../compound/BracketImage.h"
#include "Glycan.h"

namespace glycan
{
    class GlycanImage
    {
        private:
            static const double NODE_MARGIN;

            image::Image *image;

            utils::RectangleDbl resizeDrawingRectangle(Glycan *glycan, const utils::RectangleDbl rect);
            utils::RectangleDbl getNodeRegion(const Node *node);

            void scaleGlycan(Glycan *glycan, const utils::RectangleDbl rect);
            void moveOrigin(Glycan *glycan, const utils::RectangleDbl rect);

            void drawNodes(Glycan *glycan);
            void drawNode(Node *node);
            void drawEdges(Glycan *glycan);
            void drawEdge(Edge *edge);
            void drawHand(Node *node, Edge *edge);
            void drawBracket(Glycan *glycan);

            utils::PointDbl calcEdgeStartPoint(Node *firstNode, Node *secondNode);

        public:
            static const double IMAGE_PADDING;
            static const double AVERAGE_NODE_SPACE;

            GlycanImage(image::Image *image);

            void drawGlycan(Glycan *glycan);
            void drawGlycan(Glycan *glycan, utils::RectangleDbl rect);

            utils::RectangleDbl getGlycanRegion(Glycan *glycan);
    };
}

#endif
