#include "Node.h"

using namespace std;
using namespace glycan;

void Node::setSymbol(string symbol)
{
    this->symbol = symbol;
}


string Node::getSymbol() const
{
    return this->symbol;
}


void Node::setColor(const string color)
{
    this->color = color;
}


string Node::getColor() const
{
    return this->color;
}


void Node::setX(double x)
{
    this->x = x;
}


double Node::getX() const
{
    return this->x;
}


void Node::setY(double y)
{
    this->y = y;
}


double Node::getY() const
{
    return this->y;
}


void Node::addEdge(string hand, Edge *edge)
{
    if(!edge) return;

    for(size_t i=0; i<getEdgeNumber(); i++)
    {
        if(getEdge(i) == edge)
            return;
    }

    hands[edge] = hand;
    edges.push_back(edge);
}


Edge *Node::getEdge(size_t index)
{
    Edge *ret = 0x00;

    if(index >= 0 && index < getEdgeNumber())
    {
        ret = edges[index];
    }

    return ret;
}


string Node::getHand(Edge *edge)
{
    return hands[edge];
}


size_t Node::getEdgeNumber()
{
    return edges.size();
}
