#ifndef __GLYCAN__NODE__
#define __GLYCAN__NODE__

#include <string>
#include <vector>
#include <map>

namespace glycan
{
    class Edge;

    class Node
    {
        private:
            std::string symbol, color;
            double x, y;
            std::vector<glycan::Edge *> edges;
            std::map<glycan::Edge *, std::string> hands;

        public:
            void setSymbol(std::string symbol);
            std::string getSymbol() const;

            void setColor(const std::string color);
            std::string getColor() const;

            void setX(double x);
            double getX() const;

            void setY(double y);
            double getY() const;

            void addEdge(std::string hand, glycan::Edge *);
            glycan::Edge *getEdge(size_t index);
            std::string getHand(glycan::Edge *edge);
            size_t getEdgeNumber();
    };
}

#endif

