#ifndef __IMAGE_IMAGE_FT__
#define __IMAGE_IMAGE_FT__

#include <iostream>
#include <string>
#include <fstream>
#include <string.h>

#include "Image.h"
#include "../utils/Rectangle.h"
#include "../utils/Utils.h"

namespace image
{
    class ImageFT : public Image
    {
        private:
            std::string fontFile;
            int smallFontSize, largeFontSize, giantFontSize, tinyFontSize;

            int getFtFontSize(FontType type);

            char *stringToChar(std::string str);

        public:
            ImageFT();
            ImageFT(unsigned int width, unsigned int height, RGB background = RGB(255,255,255));

            void setFontFile(std::string fontFile);
            std::string getFontFile();

            void setFontSize(int size);

            void setSmallFontSize(int size);
            int getSmallFontSize();

            void setLargeFontSize(int size);
            int getLargeFontSize();

            void setGiantFontSize(int size);
            int getGiantFontSize();

            void setTinyFontSize(int size);
            int getTinyFontSize();

            utils::RectangleDbl getStringRegion(double x, double y, std::string str,
                    Align align = ALIGN_LEFT, VAlign valign = VALIGN_TOP, FontType = LARGE_FONT);

            utils::RectangleDbl getStringRegionFT(double x, double y, std::string str,
                    Align align = ALIGN_LEFT, VAlign valign = VALIGN_TOP, int size = 15);

            utils::RectangleDbl drawString(double x, double y, std::string str,
                    RGB rgb = RGB(0,0,0),
                    Align align = ALIGN_LEFT, VAlign = VALIGN_TOP, FontType size = LARGE_FONT);

            utils::RectangleDbl drawStringFT(double x, double y, std::string str,
                    RGB rgb = RGB(0,0,0),
                    Align align = ALIGN_LEFT, VAlign = VALIGN_TOP, int size = 15);
    };
}

#endif
