#include "ImageGD.h"

using namespace std;
using namespace image;
using namespace utils;

ImageGD::ImageGD() : Image()
{
}


ImageGD::ImageGD(unsigned int width, unsigned int height, RGB bg) : Image(width, height, bg)
{
}


utils::RectangleDbl ImageGD::getStringRegion(double x, double y, string str,
        Align align, VAlign valign, FontType type)
{
    gdFontPtr font = getGdFont(type);

    int width = font->w * str.length();
    int height = font->h;

    switch(align)
    {
        case ALIGN_RIGHT:
            x = x - (double)width;
            break;
        case ALIGN_CENTER:
            x = x - round((double)width/2);
            break;
        default:
            break;
    }

    switch(valign)
    {
        case VALIGN_BOTTOM:
            y = y - (double)height;
            break;
        case VALIGN_CENTER:
            y = y - round((double)height/2);
            break;
        default:
            break;
    }

    RectangleDbl ret(x, y, width, height);

    return ret;
}

utils::RectangleDbl ImageGD::drawString(
        double x, double y, string str, RGB rgb,
        Align align, VAlign valign, FontType type)
{
    gdImagePtr im = getGdImagePtr();
    int clr = getColor(rgb);
    gdFontPtr font = getGdFont(type);

    RectangleDbl rect = getStringRegion(x, y, str, align, valign, type);
    PointDbl p = rect.getLeftTop();

    gdImageString(im, font, (int)round(p.getX()), (int)round(p.getY()),
                    (unsigned char *)str.c_str(), clr);

    return rect;
}


gdFontPtr ImageGD::getGdFont(FontType type)
{
    gdFontPtr ret;
    switch(type)
    {
        case SMALL_FONT:
            ret = gdFontGetSmall();
            break;
        case GIANT_FONT:
            ret = gdFontGetGiant();
            break;
        case TINY_FONT:
            ret = gdFontGetTiny();
            break;
        default:
            ret = gdFontGetLarge();
            break;
    }

    return ret;
}

