#ifndef __IMAGE_IMAGE_GD__
#define __IMAGE_IMAGE_GD__

#include <iostream>
#include <string>
#include <gdfonts.h>
#include <gdfontl.h>
#include <gdfontg.h>
#include <gdfontt.h>

#include "Image.h"
#include "../utils/Utils.h"

namespace image
{
    class ImageGD : public Image
    {
        private:
            gdFontPtr getGdFont(FontType type);

        public:
            ImageGD();
            ImageGD(unsigned int width, unsigned int height,
                    RGB background = RGB(255,255,255));

            utils::RectangleDbl getStringRegion(double x, double y, std::string str,
                    Align align = ALIGN_LEFT, VAlign valign = VALIGN_TOP,
                    FontType type = LARGE_FONT);


            utils::RectangleDbl drawString(double x, double y, std::string str,
                    RGB rgb = RGB(0,0,0),
                    Align align = ALIGN_LEFT, VAlign = VALIGN_TOP,
                    FontType type = LARGE_FONT);
    };
}

#endif
