#include "RGB.h"

using namespace std;
using namespace image;


RGB::RGB()
{
    setRed(0);
    setGreen(0);
    setBlue(0);
}


RGB::RGB(string color)
{
    // "#ff00ff" -> "ff00ff"
    if(color.find("#") == 0)
        color = color.substr(1);

    if(color.length() != 6)
    {
        setRed(0);
        setGreen(0);
        setBlue(0);
        return;
    }

    // "ff00ff" -> "ff", "00", "ff" -> 255, 0, 255
    long red, green, blue;
    red = strtol(color.substr(0, 2).c_str(), NULL, 16);
    green = strtol(color.substr(2, 2).c_str(), NULL, 16);
    blue = strtol(color.substr(4, 2).c_str(), NULL, 16);

    setRed((unsigned int)red);
    setGreen((unsigned int)green);
    setBlue((unsigned int)blue);
}


RGB::RGB(unsigned int red, unsigned int green, unsigned int blue)
{
    setRed(red);
    setGreen(green);
    setBlue(blue);
}


void RGB::setRed(unsigned int red)
{
    if(red > MAX_DEPTH)
        red = MAX_DEPTH;

    this->red = red;
}


unsigned int RGB::getRed()
{
    return this->red;
}


void RGB::setGreen(unsigned int green)
{
    if(green > MAX_DEPTH)
        green = MAX_DEPTH;

    this->green = green;
}


unsigned int RGB::getGreen()
{
    return this->green;
}


void RGB::setBlue(unsigned int blue)
{
    if(blue > MAX_DEPTH)
        blue = MAX_DEPTH;

    this->blue = blue;
}


unsigned int RGB::getBlue()
{
    return this->blue;
}


string RGB::toString()
{
    char ret[8];
    memset(ret, 0x00, sizeof(ret));

    sprintf(ret, "#%02x%02x%02x", getRed(), getGreen(), getBlue());

    return string(ret);
}
