#include "LigandFormat.h"

using namespace std;

bool ligand::isMoleculeKCF(string kcf)
{
    istringstream in(kcf);

    string line;
    bool atom, bond;

    atom = bond = false;
    while(getline(in, line))
    {
        if(line.find("ATOM") == 0)
            atom = true;

        if(line.find("BOND") == 0)
            bond = true;
    }

    return (atom && bond);
}


bool ligand::isGlycanKCF(string kcf)
{
    istringstream in(kcf);

    string line;
    bool node, edge;

    node = edge = false;
    while(getline(in, line))
    {
        if(line.find("NODE") == 0)
            node = true;

        if(line.find("EDGE") == 0)
            edge = true;
    }

    return (node && edge);
}


bool ligand::isRpairKCF(string kcf)
{
    istringstream in(kcf);

    string line;
    bool align, entry1, entry2;

    align = entry1 = entry2 = false;
    while(getline(in, line))
    {
        if(line.find("ALIGN") == 0)
            align = true;

        if(line.find("ENTRY1") == 0)
            entry1 = true;

        if(line.find("ENTRY2") == 0)
            entry2 = true;
    }

    return (align && entry1 && entry2);
}


bool ligand::isMol(string mol)
{
    istringstream in(mol);

    string line;

    // read headers.
    getline(in, line);
    getline(in, line);
    getline(in, line);

    if(in.eof()) return false;

    getline(in, line);

    // scan atom and bond numbers.
    int scan, atom, bond;
    scan = sscanf(line.substr(0, 6).c_str(), "%3d%3d", &atom, &bond);
    if(scan != 2) return false;

    if(atom < 0 || bond < 0) return false;

    return true;
}
