#include "AtomPair.h"

using namespace std;
using namespace rpair;
using namespace compound;

AtomPair::AtomPair()
{
    setFirstAtom(0x00);
    setSecondAtom(0x00);
}


AtomPair::AtomPair(Atom *firstAtom, Atom *secondAtom, string rdm)
{
    setFirstAtom(firstAtom);
    setSecondAtom(secondAtom);
    setRDM(rdm);
}


void AtomPair::setFirstAtom(Atom *firstAtom)
{
    this->firstAtom = firstAtom;
}


Atom *AtomPair::getFirstAtom()
{
    return this->firstAtom;
}


void AtomPair::setSecondAtom(Atom *secondAtom)
{
    this->secondAtom = secondAtom;
}


Atom *AtomPair::getSecondAtom()
{
    return this->secondAtom;
}


void AtomPair::setRDM(string rdm)
{
    this->rdm = rdm;
}


string AtomPair::getRDM()
{
    return this->rdm;
}


bool AtomPair::isReactionCenter()
{
    return (getRDM().find("#R") == 0);
}


bool AtomPair::isDifferenceAtom()
{
    return (getRDM().find("#D") == 0);
}


bool AtomPair::isMatchedAtom()
{
    return (getRDM().find("#M") == 0);
}
