#ifndef __RPAIR_ATOM_PAIR__
#define __RPAIR_ATOM_PAIR__

#include <string>
#include "../compound/Atom.h"

namespace rpair
{
    class AtomPair
    {
        private:
            compound::Atom *firstAtom, *secondAtom;
            std::string rdm;

        public:
            AtomPair();
            AtomPair(
                    compound::Atom *firstAtom,
                    compound::Atom *secondAtom,
                    std::string rdm="");

            void setFirstAtom(compound::Atom *atom);
            compound::Atom *getFirstAtom();

            void setSecondAtom(compound::Atom *atom);
            compound::Atom *getSecondAtom();

            void setRDM(std::string rdm);
            std::string getRDM();

            bool isReactionCenter();
            bool isDifferenceAtom();
            bool isMatchedAtom();
    };
}

#endif
