#include "Rpair.h"

using namespace rpair;
using namespace compound;

Rpair::Rpair()
{
    firstMolecule = new compound::Molecule();
    secondMolecule = new compound::Molecule();
}


Rpair::~Rpair()
{
    delete firstMolecule;
    delete secondMolecule;
}


Molecule *Rpair::getFirstMolecule()
{
    return firstMolecule;
}


Molecule *Rpair::getSecondMolecule()
{
    return secondMolecule;
}


void Rpair::addAtomPair(AtomPair pair)
{
    atomPairs.push_back(pair);
}


int Rpair::getAtomPairNumber()
{
    return atomPairs.size();
}


AtomPair Rpair::getAtomPair(int index)
{
    AtomPair ret;

    if(index >= 0 && index < getAtomPairNumber())
    {
        ret = atomPairs[index];
    }

    return ret;
}
