#ifndef __RPAIR_RPAIR_IMAGE_
#define __RPAIR_RPAIR_IMAGE_

#include "Rpair.h"
#include "../compound/Molecule.h"
#include "../compound/MoleculeImage.h"
#include "../image/Image.h"

namespace rpair
{

    class RpairImage
    {
        private:
            static const std::string COLOR_REACTION_CENTER;
            static const std::string COLOR_DIFFERENCE_ATOM;
            static const std::string COLOR_MATCHED_ATOM;
            static const std::string COLOR_PAIRED_ATOM;

            image::Image *image;

            utils::RectangleDbl getFirstMoleculeRegion(compound::MoleculeImage *molImage, Rpair *rpair);
            utils::RectangleDbl getSecondMoleculeRegion(compound::MoleculeImage *molImage, Rpair *rpair);

            void setAlignmentColor(Rpair *rpair);
            void setAtomColor(Rpair *rpair);
            void setBondColor(Rpair *rpair, compound::Molecule *mol);

            bool isDifferenceAtom(Rpair *rpair, compound::Atom *atom);

            compound::AtomEditMode atomEditMode;

        public:
            static const double MOLECULE_SPACE;
            static const double AVERAGE_BOND_LENGTH;

            RpairImage(image::Image *image);

            void drawRpair(Rpair *rpair);

            void setAtomEditMode(compound::AtomEditMode mode);
            compound::AtomEditMode getAtomEditMode();
    };
}

#endif
