#ifndef __UTILS_DIMENSION__
#define __UTILS_DIMENSION__

#include <iostream>

namespace utils
{
    template <class T>
    class Dimension
    {
        private:
            T width, height;

        public:
            Dimension()
            {
                setWidth(0);
                setHeight(0);
            };


            Dimension(T width, T height)
            {
                setWidth(width);
                setHeight(height);
            };


            void setWidth(T width)
            {
                this->width = width;
            };


            T getWidth() const
            {
                return this->width;
            };


            void setHeight(T height)
            {
                this->height = height;
            };


            T getHeight() const
            {
                return this->height;
            };

            
            bool operator==(const Dimension<T> &other) const
            {
                if(getWidth() != other.getWidth())
                    return false;

                if(getHeight() != other.getHeight())
                    return false;

                return true;
            };


            bool operator!=(const Dimension<T> &other) const
            {
                return !(*this == other);
            };
    };

    typedef Dimension<int> DimensionInt;
    typedef Dimension<double> DimensionDbl;
}


template <typename T>
std::ostream &operator<<(std::ostream &os, const utils::Dimension<T> &ins)
{
    std::cout << "Dimension(width=" << ins.getWidth() << ", height=" << ins.getHeight() << ")";
    return os;
};

#endif
